diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
index 000c2a404..f207de2c9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
@@ -10,6 +10,7 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -24,22 +25,21 @@ public class BlockLogicMud extends BlockLogic {
     }
 
     @Override
-    public int tickDelay()
-    {
+    public int tickDelay() {
         return 5;
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
     }
 
-    private boolean isWaterNearby(final @NotNull World world, final @NotNull TilePos tilePos, int range) {
-        TilePos p = new TilePos(tilePos);
-        for (int x = tilePos.x - range; x <= tilePos.x + range; x++) {
-            for (int y = tilePos.y - range; y <= tilePos.y + range; y++) {
-                for (int z = tilePos.z - range; z <= tilePos.z + range; z++) {
-                    if (Blocks.hasTag(world.getBlockId(p.set(x, y, z)), BlockTags.IS_WATER)) {
+    private boolean isWaterNearby(final @NotNull World world, final @NotNull TilePosc tilePos, int range) {
+        TilePos queryPos = new TilePos(tilePos);
+        for (queryPos.x = tilePos.x() - range; queryPos.x <= tilePos.x() + range; queryPos.x++) {
+            for (queryPos.y = tilePos.y() - range; queryPos.y <= tilePos.y() + range; queryPos.y++) {
+                for (queryPos.z = tilePos.z() - range; queryPos.z <= tilePos.z() + range; queryPos.z++) {
+                    if (Blocks.hasTag(world.getBlockId(queryPos), BlockTags.IS_WATER)) {
                         return true;
                     }
                 }
@@ -49,12 +49,12 @@ public class BlockLogicMud extends BlockLogic {
         return false;
     }
 
-    private boolean isLavaNearby(final @NotNull World world, final @NotNull TilePos tilePos) {
-        TilePos p = new TilePos(tilePos);
-        for (int x = tilePos.x - 1; x <= tilePos.x + 1; x++) {
-            for (int y = tilePos.y - 1; y <= tilePos.y + 1; y++) {
-                for (int z = tilePos.z - 1; z <= tilePos.z + 1; z++) {
-                    if (Blocks.hasTag(world.getBlockId(p.set(x, y, z)), BlockTags.IS_LAVA)) {
+    private boolean isLavaNearby(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos(tilePos);
+        for (queryPos.x = tilePos.x() - 1; queryPos.x <= tilePos.x() + 1; queryPos.x++) {
+            for (queryPos.y = tilePos.y() - 1; queryPos.y <= tilePos.y() + 1; queryPos.y++) {
+                for (queryPos.z = tilePos.z() - 1; queryPos.z <= tilePos.z() + 1; queryPos.z++) {
+                    if (Blocks.hasTag(world.getBlockId(queryPos), BlockTags.IS_LAVA)) {
                         return true;
                     }
                 }
@@ -64,20 +64,20 @@ public class BlockLogicMud extends BlockLogic {
         return false;
     }
 
-    private boolean canBecomeWet(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private boolean canBecomeWet(final @NotNull World world, final @NotNull TilePosc tilePos) {
         // If there's water within 1 block, it can become wet
-        if(isWaterNearby(world, tilePos, 1))
+        if (isWaterNearby(world, tilePos, 1))
             return true;
 
         // If there's water 3 blocks...
-        if(isWaterNearby(world, tilePos, 3)){
-            TilePos p = new TilePos(tilePos);
-            for (int x = tilePos.x - 1; x <= tilePos.x + 1; x++) {
-                for (int y = tilePos.y - 1; y <= tilePos.y + 1; y++) {
-                    for (int z = tilePos.z - 1; z <= tilePos.z + 1; z++) {
+        if (isWaterNearby(world, tilePos, 3)) {
+            TilePos queryPos = new TilePos(tilePos);
+            for (queryPos.x = tilePos.x() - 1; queryPos.x <= tilePos.x() + 1; queryPos.x++) {
+                for (queryPos.y = tilePos.y() - 1; queryPos.y <= tilePos.y() + 1; queryPos.y++) {
+                    for (queryPos.z = tilePos.z() - 1; queryPos.z <= tilePos.z() + 1; queryPos.z++) {
                         //...And the block is next to another wet mud block, it can become wet
-                        int bID = world.getBlockId(p.set(x, y, z));
-                        if (bID == Blocks.MUD.id() || (bID == Blocks.FARMLAND_DIRT.id() && BlockLogicFarmland.isWet(world.getBlockData(p)))) {
+                        int bID = world.getBlockId(queryPos);
+                        if (bID == Blocks.MUD.id() || (bID == Blocks.FARMLAND_DIRT.id() && BlockLogicFarmland.isWet(world.getBlockData(queryPos)))) {
                             return true;
                         }
                     }
@@ -88,34 +88,38 @@ public class BlockLogicMud extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay());
     }
 
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(this, 1, data) };
+        return new ItemStack[]{new ItemStack(this, 1, data)};
     }
 
-    private void tryToFall(@NotNull World world, @NotNull TilePos tilePos) {
-        if(world.getBlockId(tilePos) == Blocks.MUD_BAKED.id()){
+    private void tryToFall(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (world.getBlockId(tilePos) == Blocks.MUD_BAKED.id()) {
             return;
         }
 
-        if(canFallBelow(world, tilePos.down()) && tilePos.y >= 0) {
+        TilePos queryPos = new TilePos();
+        if (canFallBelow(world, tilePos.down(queryPos)) && tilePos.y() >= 0) {
             byte radius = 32;
-            if(!world.areBlocksLoaded(tilePos.add(-radius, -radius, -radius), tilePos.add(radius, radius, radius))) {
+            if (!world.areBlocksLoaded(tilePos.add(-radius, -radius, -radius, new TilePos()), tilePos.add(radius, radius, radius, new TilePos()))) {
                 world.setBlockIdNotify(tilePos, 0);
-                TilePos p = tilePos.down();
-                while (canFallBelow(world, p) && p.y >= 0) {
-                    p.y--;
+
+                int checkX = tilePos.x();
+                int checkY = tilePos.y() - 1;
+                int checkZ = tilePos.z();
+                while (canFallBelow(world, queryPos.set(checkX, checkY, checkZ)) && checkY >= 0) {
+                    checkY--;
                 }
-                if(p.y > 0) {
-                    world.setBlockIdNotify(p, this.block.id());
+                if (checkY > 0) {
+                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
 
                 }
             } else {
-                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, tilePos.x + 0.5, tilePos.y + 0.5, tilePos.z + 0.5, this.block.id(), 0, null);
+                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, tilePos.x() + 0.5, tilePos.y() + 0.5, tilePos.z() + 0.5, this.block.id(), 0, null);
                 world.entityJoinedWorld(entityFallingBlock);
             }
         }
@@ -128,10 +132,10 @@ public class BlockLogicMud extends BlockLogic {
 
 
     @Override
-    public void updateTick(final @NotNull World world, @NotNull final TilePos tilePos, final @NotNull Random rand, boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, boolean isRandomTick) {
         // hydrate mud
-        if(this.isHardened) {
-            if(!isLavaNearby(world, tilePos)) {
+        if (this.isHardened) {
+            if (!isLavaNearby(world, tilePos)) {
                 if (canBecomeWet(world, tilePos)) {
                     world.setBlockId(tilePos, Blocks.MUD.id());
                     world.notifyBlockChange(tilePos, Blocks.MUD.id());
@@ -141,12 +145,11 @@ public class BlockLogicMud extends BlockLogic {
         }
 
         // dry out mud
-        if(!this.isHardened){
-            if(isLavaNearby(world, tilePos) || world.dimension == Dimension.NETHER) {
-                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x + 0.5D, tilePos.y + 0.5D, tilePos.z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
-                for(int l = 0; l < 8; l++)
-                {
-                    world.spawnParticle("largesmoke", (double)tilePos.x + Math.random(), (double)tilePos.y + Math.random(), (double)tilePos.z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
+        if (!this.isHardened) {
+            if (isLavaNearby(world, tilePos) || world.dimension == Dimension.NETHER) {
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
+                for (int l = 0; l < 8; l++) {
+                    world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
                 }
                 world.setBlockId(tilePos, Blocks.MUD_BAKED.id());
                 world.notifyBlockChange(tilePos, Blocks.MUD_BAKED.id());
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
index 467d96420..261b8d879 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
@@ -5,16 +5,15 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicMushroom extends BlockLogicFlower
-{
+public class BlockLogicMushroom extends BlockLogicFlower {
 
-	public BlockLogicMushroom(@NotNull Block<?> block)
-    {
+    public BlockLogicMushroom(@NotNull Block<?> block) {
         super(block);
         float f = 0.2F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 2.0F, 0.5F + f);
@@ -22,16 +21,12 @@ public class BlockLogicMushroom extends BlockLogicFlower
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
-        if(rand.nextInt(25) == 0)
-        {
-            TilePos checkPos = tilePos.add(rand.nextInt(3) - 1,rand.nextInt(2) - rand.nextInt(2), rand.nextInt(3) - 1);
-            if(world.isAirBlock(checkPos) && canStay(world, checkPos))
-            {
-                checkPos.set(tilePos.x + rand.nextInt(3) - 1, checkPos.y, tilePos.z + rand.nextInt(3) - 1);
-                if(world.isAirBlock(checkPos) && canStay(world, checkPos))
-                {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (rand.nextInt(25) == 0) {
+            TilePos checkPos = tilePos.add(rand.nextInt(3) - 1, rand.nextInt(2) - rand.nextInt(2), rand.nextInt(3) - 1, new TilePos());
+            if (world.isAirBlock(checkPos) && canStay(world, checkPos)) {
+                checkPos.set(tilePos.x() + rand.nextInt(3) - 1, checkPos.y, tilePos.z() + rand.nextInt(3) - 1);
+                if (world.isAirBlock(checkPos) && canStay(world, checkPos)) {
                     world.setBlockIdNotify(checkPos, this.block.id());
                 }
             }
@@ -39,46 +34,47 @@ public class BlockLogicMushroom extends BlockLogicFlower
     }
 
     @Override
-	protected boolean mayPlaceOn(int blockId)
-    {
+    protected boolean mayPlaceOn(int blockId) {
         return Blocks.solid[blockId];
     }
 
     @Override
-    public boolean canStay(@NotNull World world, @NotNull TilePos tilePos)
-    {
-        if(tilePos.y < 0 || tilePos.y >= world.getHeightBlocks()) {
+    public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (tilePos.y() < 0 || tilePos.y() >= world.getHeightBlocks()) {
             return false;
         } else {
-            return world.getFullBlockLightValue(tilePos) < 13 && mayPlaceOn(world.getBlockId(tilePos.down()));
+            return world.getFullBlockLightValue(tilePos) < 13 && mayPlaceOn(world.getBlockId(tilePos.down(new TilePos())));
         }
     }
 
     @Override
-    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onBonemealUsed(@NotNull ItemStack itemStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         Random rand = world.rand;
         if (!world.isClientSide && this.canBeBonemealed) {
             if (player == null || player.getGamemode().consumeBlocks()) {
                 itemStack.stackSize--;
             }
-            TilePos p = new TilePos(tilePos);
-            label0:
+
+            TilePos queryPos = new TilePos();
+            outer:
             for (int j1 = 0; j1 < 32; j1++) {
-                p.set(tilePos.x, tilePos.y, tilePos.z);
+                int checkX = tilePos.x();
+                int checkY = tilePos.y();
+                int checkZ = tilePos.z();
                 for (int j2 = 0; j2 < j1 / 16; j2++) {
-                    p.x += rand.nextInt(3) - 1;
-                    p.y += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
-                    p.z += rand.nextInt(3) - 1;
-                    if (world.getFullBlockLightValue(p) >= 13 || !mayPlaceOn(world.getBlockId(p.down()))) {
-                        continue label0;
+                    checkX += rand.nextInt(3) - 1;
+                    checkY += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
+                    checkZ += rand.nextInt(3) - 1;
+                    if (world.getFullBlockLightValue(queryPos.set(checkX, checkY, checkZ)) >= 13 || !mayPlaceOn(world.getBlockId(queryPos.set(checkX, checkY - 1, checkZ)))) {
+                        continue outer;
                     }
                 }
 
-                if (world.getBlockId(p) != 0) {
+                if (world.getBlockId(queryPos.set(checkX, checkY, checkZ)) != 0) {
                     continue;
                 }
                 if (rand.nextFloat() > 0.85) {
-                    world.setBlockIdNotify(p, this.block.id());
+                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
                 }
             }
             return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
index b374300e2..eb01c7bd0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
@@ -1,32 +1,35 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
 public class BlockLogicNetherrackIgneous extends BlockLogic {
     public BlockLogicNetherrackIgneous(@NotNull Block<?> block) {
-        super(block, Material.netherrack);
+        super(block, Materials.NETHERRACK);
         block.setTicking(true);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         float f = 0.125F;
-        return AABB.fromPool(tilePos.x, tilePos.y, tilePos.z, tilePos.x + 1, tilePos.y + 1 - f, tilePos.z + 1);
+        return new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1, tilePos.y() + 1 - f, tilePos.z() + 1);
     }
 
     @Override
-    public void onEntityCollision(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity) {
+    public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
         if (entity instanceof EntityItem) return; // Don't burn items for this block
         entity.fireHurt();
     }
@@ -37,30 +40,31 @@ public class BlockLogicNetherrackIgneous extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         world.scheduleBlockUpdate(tilePos, this.block.id(), tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
     }
 
-    public boolean canMelt(@NotNull World world, @NotNull TilePos tilePos) {
+    public boolean canMelt(@NotNull World world, @NotNull TilePosc tilePos) {
         boolean canMelt = false;
+        TilePos queryPos = new TilePos();
         for (Direction dir : Direction.directions) {
-            Block<?> block = world.getBlock(tilePos.add(dir));
-            Material adjacentMaterial = block == null ? Material.air : block.getMaterial();
-            if (adjacentMaterial == Material.water) {
+            Block<?> block = world.getBlock(tilePos.add(dir, queryPos));
+            Material adjacentMaterial = block == null ? Materials.AIR : block.getMaterial();
+            if (adjacentMaterial == Materials.WATER) {
                 return false;
             }
-            canMelt |= adjacentMaterial == Material.lava;
+            canMelt |= adjacentMaterial == Materials.LAVA;
         }
         return canMelt;
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         if (canMelt(world, tilePos)) {
             world.setBlockIdNotify(tilePos, Blocks.FLUID_LAVA_FLOWING.id());
         }
